﻿from tkinter import *
import time,math
#■繰返し回数（点の数に一致:多くすると精細な図形になるが遅くなる）
MAX=5000
NSEP=800
def intX(X) : return int(X * 40 + 50.5)
def intY(Y) : return int(150.5-Y * 10)

#■表示用計算
def Map(k, B,DT):
    global MAX, NSEP
    Ctab=["#FF0000", "#007700","#0000FF", "#777700","#770077","#007777","#770000"]
    T=0; X = 0.2;Y = 0.1; LOOP=MAX+200-1;  NK=1
    #表示要素数での繰返し
    for j in range(LOOP):
        if j% 200==0:#描画中の表示
            canvas.delete("DT")
            canvas.create_text(100,30,text="描画中です(%2d %%)" % int(j/LOOP*100),
                               font=('Times',10),fill='red', tag="DT")
            canvas.create_text(100,50,text="■"*NK,
                               font=('Times',10),fill='red', tag="DT")
            NK+=1
            if NK>20: NK=1
            root.update()
        for i in range(NSEP):#ジャパニーズ・アトラクタの計算
            #DX = Y * DT ; DY = (-k * Y - X * X * X + B * math.cos(T)) * DT
            #XN = X + DX ; YN = Y + DY
            XN = X + Y * DT ;YN = Y + (-k * Y - X * X * X + B * math.cos(T)) * DT
            T += DT ; X = XN ; Y = YN
            if math.isnan(X):
                print("Xの計算でオーバフローが起きました。j=%d, i=%d,  B=%5.2f。Xを0とします。" %(j,i,B))
                X=0
            if math.isnan(Y):
                print("Yの計算でオーバフローが起きました。j=%d, i=%d,  B=%5.2f。Yを0とします。"%(j,i,B))
                Y=0
        if j>=200:#ある程度(200回)計算した後を表示
            XX=intX(X); YY=intY(Y); C=Ctab[j%7]
            
            canvas.coords(FID[j-200],XX,YY,XX,YY) #表示
            #C="#%02X%02X%02X" % ((jj>>16) & 0xFF, (jj>>8) & 0xFF,jj & 0xFF)
            canvas.itemconfig(FID[j-200], fill=C)
    canvas.delete("DT") #描画中表示削除
    root.update()
#■待ち処理等
def wait():
    tk.update_idletasks()
    time.sleep(0.0001)
def strdt(DT):
    return "B = %+5.2f" % DT
#■ マウスイベントによる次の描画
def leftMouseDown(event): 
    global B, DB, k,DT; B+=DB
    if B>12.105:B=11.7
    canvas.itemconfig(strID,text=strdt(B))
    Map(k,B,DT)
#■メイン処理
#キャンバスの定義
root=Tk()
root.title("Japanese Attractor")
canvas=Canvas(root, width=250,height=250)
canvas.pack()
#表示用の点の準備
FID=[0 for j in range(MAX)]
for j in range(MAX):
    FID[j]=canvas.create_rectangle(0,0,0,0,fill="#007700", outline='')
#k=0.1; B=11.7; DT=2*math.pi/NSEP; DB=0.02
k=0.1; B=12.0; DT=2*math.pi/NSEP; DB=0.02
strID=canvas.create_text(100,10,text=strdt(B), font=('ＭＳ ゴシック',10))
#開始
canvas.bind("<Button-1>",leftMouseDown)
Map(k,B,DT)
root.mainloop()





    
